/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
import { ChildProcessWithoutNullStreams } from "node:child_process";
import { ProtectCamera, ProtectPackageCamera } from "./protect-camera.js";
import { Readable, Writable } from "node:stream";
import { EventEmitter } from "node:events";
import { ProtectLogging } from "./protect-types.js";
import { ProtectNvr } from "./protect-nvr.js";
import { StreamRequestCallback } from "homebridge";
export interface PortInterface {
    addressVersion: string;
    port: number;
}
export declare class FfmpegProcess extends EventEmitter {
    protected callback: StreamRequestCallback | null;
    protected commandLineArgs: string[];
    hasError: boolean;
    isEnded: boolean;
    private isLogging;
    private isPrepared;
    isStarted: boolean;
    protected isVerbose: boolean;
    private ffmpegTimeout?;
    protected readonly log: ProtectLogging;
    protected readonly nvr: ProtectNvr;
    protected process: ChildProcessWithoutNullStreams | null;
    protected protectCamera: ProtectCamera | ProtectPackageCamera;
    protected stderrLog: string[];
    constructor(protectCamera: ProtectCamera | ProtectPackageCamera, commandLineArgs?: string[], callback?: StreamRequestCallback);
    protected prepareProcess(commandLineArgs?: string[], callback?: StreamRequestCallback): void;
    protected start(commandLineArgs?: string[], callback?: StreamRequestCallback, errorHandler?: (errorMessage: string) => Promise<void>): void;
    protected configureProcess(errorHandler?: (errorMessage: string) => Promise<void>): void;
    protected stopProcess(): void;
    stop(): void;
    protected logFfmpegError(exitCode: number, signal: NodeJS.Signals): void;
    get stdin(): Writable | null;
    get stdout(): Readable | null;
    get stderr(): Readable | null;
}
