/// <reference types="node" />
import { ProtectApi, ProtectNvrConfig } from "unifi-protect";
import { ProtectDeviceConfigTypes, ProtectDevices, ProtectLogging } from "./protect-types.js";
import { ProtectNvrOptions } from "./protect-options.js";
import { ProtectDevice } from "./protect-device.js";
import { ProtectMqtt } from "./protect-mqtt.js";
import { ProtectNvrEvents } from "./protect-nvr-events.js";
import { ProtectNvrSystemInfo } from "./protect-nvr-systeminfo.js";
import { ProtectPlatform } from "./protect-platform.js";
export declare class ProtectNvr {
    private api;
    config: ProtectNvrOptions;
    readonly configuredDevices: {
        [index: string]: ProtectDevices;
    };
    events: ProtectNvrEvents;
    private isEnabled;
    private hap;
    private lastMotion;
    private lastRing;
    private liveviews;
    logApiErrors: boolean;
    readonly log: ProtectLogging;
    mqtt: ProtectMqtt | null;
    private name;
    nvrOptions: ProtectNvrOptions;
    ufpApi: ProtectApi;
    systemInfo: ProtectNvrSystemInfo | null;
    platform: ProtectPlatform;
    ufp: ProtectNvrConfig;
    private unsupportedDevices;
    constructor(platform: ProtectPlatform, nvrOptions: ProtectNvrOptions);
    private ufpUpdate;
    private ufpStartupHandler;
    private configureNvr;
    private configureDefaultDoorbellMessage;
    private addProtectDevice;
    private discoverDevices;
    addHomeKitDevice(device: ProtectDeviceConfigTypes): ProtectDevice | null;
    private discoverAndSyncAccessories;
    private cleanupDevices;
    removeHomeKitDevice(protectDevice: ProtectDevice): void;
    resetNvrConnection(): Promise<void>;
    deviceLookup(deviceId: string): ProtectDevices | null;
    optionEnabled(device: ProtectDeviceConfigTypes | ProtectNvrConfig | null, option?: string, defaultReturnValue?: boolean, address?: string, addressOnly?: boolean): boolean;
    optionGet(device: ProtectDeviceConfigTypes | null, option: string, address?: string): string | undefined;
    sleep(ms: number): Promise<NodeJS.Timeout>;
}
