import { ProtectDeviceConfigTypes } from "./protect-types.js";
import { ProtectNvrConfig } from "unifi-protect";
export interface ProtectOptions {
    controllers: ProtectNvrOptions[];
    debugAll: boolean;
    ffmpegOptions: string[];
    motionDuration: number;
    options: string[];
    ringDuration: number;
    verboseFfmpeg: boolean;
    videoEncoder: string;
    videoProcessor: string;
}
export interface ProtectNvrOptions {
    address: string;
    defaultDoorbellMessage: string;
    doorbellMessages: {
        duration: number;
        message: string;
    }[];
    mqttTopic: string;
    mqttUrl: string;
    name: string;
    username: string;
    password: string;
}
export declare const featureOptionCategories: {
    description: string;
    name: string;
    validFor: string[];
}[];
export declare const featureOptions: {
    [index: string]: FeatureOption[];
};
export interface FeatureOption {
    default: boolean;
    description: string;
    hasFeature?: string;
    hasProperty?: string;
    name: string;
}
export declare function optionEnabled(configOptions: string[], nvrUfp: ProtectNvrConfig | null, device: ProtectDeviceConfigTypes | ProtectNvrConfig | null, option?: string, defaultReturnValue?: boolean, address?: string, addressOnly?: boolean): boolean;
