import { CameraRecordingConfiguration, CameraRecordingDelegate, HDSProtocolSpecificErrorReason, RecordingPacket } from "homebridge";
import { ProtectCamera } from "./protect-camera.js";
export declare class ProtectRecordingDelegate implements CameraRecordingDelegate {
    private _isRecording;
    private readonly accessory;
    private readonly api;
    private readonly hap;
    private ffmpegStream;
    private isInitialized;
    private isTransmitting;
    private readonly log;
    private readonly maxRecordingDuration;
    private nvr;
    private readonly protectCamera;
    private recordingConfig;
    private rtspEntry;
    private transmittedSegments;
    private readonly timeshift;
    private timeshiftedSegments;
    private transmitListener;
    constructor(protectCamera: ProtectCamera);
    updateRecordingActive(active: boolean): Promise<void>;
    updateRecordingConfiguration(configuration: CameraRecordingConfiguration | undefined): void;
    handleRecordingStreamRequest(streamId: number): AsyncGenerator<RecordingPacket>;
    acknowledgeStream(streamId: number): Promise<void>;
    closeRecordingStream(streamId: number, reason: HDSProtocolSpecificErrorReason | undefined): Promise<void>;
    private configureTimeshifting;
    private startTransmitting;
    private stopTransmitting;
    restartTimeshifting(): Promise<void>;
    get isRecording(): boolean;
    get recordingConfiguration(): CameraRecordingConfiguration | null;
}
